/* This file is Copyright 2000 Level Control Systems.  See the included LICENSE.txt file for details. */

//! author="Jeremy Friesner"

/******************************************************************************
/
/	File:		PortableMacros.h
/
/	Description:	Some macros that I like to use....
/
*******************************************************************************/

#ifndef _PORTABLEMACROS_H
#define _PORTABLEMACROS_H

#include <stdio.h>
#include <stdlib.h>

#define WARN_OUT_OF_MEMORY printf("ERROR--OUT OF MEMORY!  (%s:%i)\n",__FILE__,__LINE__)
#define WARN(X) printf("WARNING (%s:%i) %s\n",__FILE__,__LINE__, X)
#define ERROR(X) printf("ERROR (%s:%i) %s\n",__FILE__,__LINE__, X)
#define UNLESS(x) if(!(x))
#define ASSERT(x,msg) if(!(x)) {printf("ASSERTION FAILED: (%s:%i) "msg"\n", __FILE__,__LINE__); *((long *)0) = 0xdeadbeef;}

#ifndef __BEOS__
#define closesocket close
#endif

#endif /* _PORTABLEMACROS_H */

