/* This file is Copyright 2000 Level Control Systems.  See the included LICENSE.txt file for details. */  

#include <stdio.h>

#include "refcount/PortableRefCount.h"

class TestClass
{
public:
   TestClass() : _name("Default") {printf("Constructing [%s]\n",_name);}
   TestClass(const char * name) : _name(name) {printf("Constructing [%s]\n",_name);}
   ~TestClass() {printf("Destroying [%s]\n",_name);}

   const char * GetName() const {return _name;}

private:
   const char * _name;
};

// This program exercises the PortableRef class.
void main(void) 
{
   PortableRef<const TestClass>::RefPool trpool;
   PortableRef<const TestClass>::ItemPool tpool;
 
   {
      PortableRef<const TestClass> * refPtr = NULL;
      PortableRef<const TestClass> extraRef;
      {
         printf("1\n");
         PortableRef<const TestClass> testRef(new TestClass("Test"), &tpool, &trpool);
         printf("2\n");
         extraRef = testRef;
         printf("3\n");
         refPtr = new PortableRef<const TestClass>(extraRef);
         printf("4\n");

         PortableRef<const TestClass> copy(*refPtr);
         printf("5\n");
      }
      printf("6\n");
      delete refPtr;
      printf("7 [%s]\n", extraRef.GetItemPointer()->GetName());
   }

   printf("Checking for memory leaks... watch free mem in about box, press CTRL-C when done\n");
   while(1)
   {
      PortableRef<const TestClass> r2(tpool.GetObject(), &tpool, &trpool);
   }
}
